#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <malloc.h>
#include <fcntl.h>
#include <graph.h>
#include <i86.h>
#include <conio.h>

#include "boulder.h"

//###################################################################
//# Globale Variablen                                               #
//###################################################################

BYTE *grafik; //Peter was here :->
BYTE *grafik4planes; // Chrisi was here 8-?
BYTE *schrift;
BYTE *pal;
union REGS regs;
struct SREGS sregs;
struct feld_element feld[FELD_AUFL_Y][FELD_AUFL_X];
int anz_green_slime = 0;
int anz_collected_dias = 0;
int max_anz_green_slime =  800;
char green_slime_frei = TRUE;
char green_slime_im_level = FALSE;
BYTE *feld_grafik[ANZ_SPRITES ];
int graphik_modus;
BYTE feldx =0,feldy=0;
signed char deltax=0,deltay=0;

BYTE screenx=20, screeny=13;

BYTE hero_x = 0, hero_y = 0;
BYTE level_aufl_x=FELD_AUFL_X;
BYTE level_aufl_y=FELD_AUFL_Y;
short time_left=199;
long score=123456;

//###################################################################
//# Interne Funktionen                                              #
//###################################################################
void green_slime_morph();

//###################################################################
void error (char *text)
{
    printf("%s", text);
    exit (-1);
}
//###################################################################
int my_open( char *dateiname, int oflag )
{
   int handle =  open( dateiname, oflag );
   if (handle == -1) error ("Datei nicht gefunden...");
   return handle;
}

//###################################################################
void *my_alloc( size_t size )
{
   void *ptr;
   ptr = malloc (size);
   if (ptr == NULL) error ("Nicht genug Speicher...");
   return ptr;
}

//###################################################################
//# void grafik_laden()
//###################################################################
void grafik_laden()
{
   int handle,i;
   short int *ptr;
   BYTE *ptr2;
   printf("Loading Graphics...\n");
   handle = my_open ("boulder.vga", O_BINARY | O_RDONLY);
   // Grafik fr putimage berechnen
   for (i=0;i<ANZ_SPRITES;i++)
   {
      ptr = (short int *) my_alloc(16*16+6);
      ptr[0] = 16;
      ptr[1] = 16;
      ptr[2] = 8;
      ptr2 = (BYTE *) &ptr[3];
      read(handle, ptr2, 256);
      feld_grafik[ i ] = (BYTE *) ptr;
   }

   // Grafik linear reinladen
   lseek (handle,0,SEEK_SET);
   grafik = (BYTE *) my_alloc(SPRITE_MEM);
   read(handle, grafik, SPRITE_MEM);

   close (handle);

   // Grafik auf 4 Planes umsortieren
   grafik4planes = (BYTE *) my_alloc(SPRITE_MEM);
   for (i=0;i<SPRITE_MEM/4;i++)
   {
      grafik4planes[i+0*SPRITE_MEM/4] = grafik[4*i+0];
      grafik4planes[i+1*SPRITE_MEM/4] = grafik[4*i+1];
      grafik4planes[i+2*SPRITE_MEM/4] = grafik[4*i+2];
      grafik4planes[i+3*SPRITE_MEM/4] = grafik[4*i+3];
   }

   handle = my_open ("schrift.vga", O_BINARY | O_RDONLY);
   schrift = (BYTE *) my_alloc(15104);
   read(handle, schrift, 15104);
   close (handle);

   handle = my_open ("default.plt", O_BINARY | O_RDONLY);
   pal = (BYTE *) my_alloc(768);
   read(handle, pal, 768);
   close (handle);

}

//###################################################################
//# void init_feld()
//###################################################################
void init_feld()
{
   int x,y;
   for (x=0;x<FELD_AUFL_X;x++)
      for (y=0;y<FELD_AUFL_Y;y++)
      {
         feld[y][x].inhalt = earth;
         feld[y][x].aussehen = earth;
      }
   for (x=0;x<FELD_AUFL_X;x++)
   {
        feld[0][x].inhalt = steel;
        feld[0][x].aussehen = steel;
        feld[FELD_AUFL_Y-1][x].inhalt = steel;
        feld[FELD_AUFL_Y-1][x].aussehen = steel;
   }
   for (y=0;y<FELD_AUFL_Y;y++)
   {
        feld[y][0].inhalt = steel;
        feld[y][0].aussehen = steel;
        feld[y][FELD_AUFL_X-1].inhalt = steel;
        feld[y][FELD_AUFL_X-1].aussehen = steel;
   }
   feld[1][1].inhalt = hero;
   feld[1][1].aussehen = hero;
}

//###################################################################
//# void zeige_feld()
//###################################################################
void zeige_feld()
{
  paint_feld(graphik_modus, 0, feldx, feldy, 21, 14);
}

//###################################################################
void scroll_2_spieler()
{
 // hero_x, hero_y
// TODO: nach unten gehen klappt noch nicht ganz

   if (hero_x < feldx+5) // nach links gegangen ?
   {
      deltax--;
      if (deltax < 0)
      {
         if (feldx != 0)
         {
            feldx--; deltax=15;
         }
         else deltax = 0;
      }
   }
   else if (hero_x > feldx+screenx-5) // nach rechts gegangen ?
   {
      deltax++;
      if (deltax >= 16)
      {
         if (feldx < level_aufl_x - screenx)
         {
            feldx++;
         }
         deltax = 0;
      }
      if (feldx >= level_aufl_x - screenx && deltax == 1) deltax = 0;
   }
   else
   {
      if (deltax != 0)
      {
         deltax --;
      }
   }

//##############################################################
   if (hero_y < feldy+5) // nach oben gegangen ?
   {
      deltay--;
      if (deltay < 0)
      {
         if (feldy != 0)
         {
            feldy--; deltay=15;
         }
         else deltay = 0;
      }
   }
   else if (hero_y > feldy+screeny-5) // nach unten gegangen ?
   {
      if (feldy < level_aufl_y - screeny)
      {
         deltay++;
         if (deltay >= 16)
         {
            feldy++;
            deltay = 0;
         }
      }
      else if (deltay < 8) deltay ++;
   }
   else
   {
      if (hero_y == feldy+5)    // Krzlich nach oben gegeangen?
         if (deltay != 0)
         {
            deltay --;
         }
      if (hero_y == feldy+screeny-5 && deltay < 8) deltay ++;

   }
}

//###################################################################
void quit_game()
{
   exit(0);
}

void reset_video_mode()
{
   _setvideomode(_DEFAULTMODE);
}

//###################################################################
//# Main
//###################################################################
main()
{
        int i,x,y,xpos,ypos;
        int peter_counter;
        int alter_tastencode;

        grafik_laden();

        // graphik_modus = _VRES256COLOR;
        graphik_modus = MODE_X_256_COLORS;

        atexit(reset_video_mode);

        if (graphik_modus == MODE_X_256_COLORS)
        {
           setze_mode_x();
           kopiere_sprites(grafik, ANZ_SPRITES * 256, START_SPRITES);
           screenx = 20;
           screeny = 13;
        }
        else _setvideomode(graphik_modus);

        setze_palette( pal );

        xpos = ypos = 0;
        for (i=0;i<ANZ_SPRITES;i++)
        {
           if (graphik_modus == MODE_X_256_COLORS)
              paint_block(i,xpos,ypos);
           else
              setze_spiel_element(xpos,ypos,i);

           xpos += 16;
           if (xpos > 300)
           {
                   xpos = 0;
                   ypos += 16;
           }
        }

        if (graphik_modus != MODE_X_256_COLORS)
        {
           for (i=0;i<15104/256;i++)
           {
              for (y=0;y<16;y++)
                 for (x=0;x<16;x++)
                 {
                   _setcolor(schrift[(i<<8) | (y<<4) | x]);
                   _setpixel(xpos+x,ypos+y);
                 }
              xpos += 17;
              if (xpos > 300)
              {
                 xpos = 0;
                 ypos += 17;
              }
           }
        }

        getch();

        init_flames();

        init_feld();
        zeige_feld();
        init_events();

        install_kbd_handler();
        install_mouse_handler();

        peter_counter = 0;

        while (1)
        {
            if (peter_counter > 0)
            {
               peter_counter--;
            }
            else
            {
               calc_flames();

               set_debug_farbe(9);

               animate_tables();
               handle_events();
               alter_tastencode = get_kb_command();
               set_debug_farbe(0);

               peter_counter = 5;
            }


            if (graphik_modus == MODE_X_256_COLORS)
            {
               scroll_2_spieler();
               set_other_page(deltax, deltay);
               zeige_feld();

               char flame_str_1[30];
               sprintf(flame_str_1,"00&00 %03d %03d %06d",
                anz_collected_dias, time_left, score);
               set_flames_str(flame_str_1, 12, 3);

               //setze_sprite(test_col, 256,4,0,32);

            }
            handle_menu_events();
            // print_status();
        }
}
