#include <malloc.h>
typedef unsigned char BYTE;
typedef unsigned short WORD;
typedef unsigned long DWORD;

#define TRANS_FARBE 32
#define FELD_AUFL_X 38
#define FELD_AUFL_Y 24
#define ANZ_SPRITES 111
#define SPRITE_MEM ANZ_SPRITES * 256
#define BILD_SIZE ((320+16)*(208+16)/4)
#define START_BILD_1 0
#define START_BILD_2 (START_BILD_1 + BILD_SIZE)
#define START_SPRITES (START_BILD_2 + BILD_SIZE)
#define START_SCHRIFT (START_SPRITES + SPRITE_MEM / 4)
#define MODE_X_256_COLORS 1324555

#define B(_n) 128 * ( (_n) / 10000000)      + \
               64 * (((_n) / 1000000)  & 1) + \
               32 * (((_n) / 100000)   & 1) + \
               16 * (((_n) / 10000)    & 1) + \
                8 * (((_n) / 1000)     & 1) + \
                4 * (((_n) / 100)      & 1) + \
                2 * (((_n) / 10)       & 1) + \
                    ( (_n)             & 1)

//###################################################################
//# Structures and enums                                            #
//###################################################################
enum boolean {FALSE,TRUE};
enum inhalt_typ { fire_cracker=0, butter_fly=1, diamond=2,
                  blue_slime=3, green_slime=4, milling_wall=5,
                  hero=6,
                  // ENDE DER ANIMATIONEN ???? (Frage von Chrisi)

                  victim=44, wall=56, green_bomb=65, empty=76,
                  explo_nix=77, explo_dia=78,
                  red_bomb=95, stone=96, earth=97, steel=98,
                  x_grow=100,in, out, out_hidden, in_frame,
                  y_grow=105,  menu_right, menu_left, mouse,
                  frame,bomb_cross,
                  bald_explo_nix,
                  bald_explo_dia };

enum richtung { north, west, south, east };
enum kbd_keys {up=1, left=2, down=4, right=8, shift=16,
               esc=32, pause=64, print=128, enter=256};
// Rckegabewerte der Fkt get_kb_command
// Einzeln mit | verbunden

struct feld_element
{
   BYTE inhalt;
   BYTE aussehen;
   union
   {
        BYTE richtung;
        BYTE counter;
   };
};

struct pos
{
        short unsigned int x;
        short unsigned int y;
};
//###################################################################
//# Definitionen fr die liebe VGA
//###################################################################

#define SC_INDEX       0x3c4             // Indexregister des Sequencer-Ctrl.
#define SC_MAP_MASK    0x2               // Nummer des Map-Mask-Registers
#define SC_MEM_MODE    0x4               // Nummer des Memory-Mode-Registers

#define GC_INDEX       0x3ce             // Indexregister des Graphics-Ctrl.
#define GC_READ_MAP    0x4               // Nummer des Read-Map-Registers
#define GC_GRAPH_MODE  0x5               // Nummer des Graphics-Mode-Registers
#define GC_MISCELL     0x6               // Nummer des Miscellaneous-Registers

#define AC_INDEX       0x3c0             // Indexregister des Attribute-Controllers
#define AC_MODE_CTRL   (0x10 | 0x20)     // Nummer des Mode-Control-Regs.
#define AC_HOR_PP      (0x13 | 0x20)     // Nummer des Horizontal-Pel-Panning-Reg.
#define AC_OVERSCAN    (0x11 | 0x20)     // Nummer des Overscan-Regs.

#define CRTC_INDEX     0x3d4             // Indexregistes des CRT-Controllers
#define CC_VERT_PP     0x8               // Nummer des Vertical-Pel_Panning-Reg.
#define CC_MAX_SCAN    0x9               // Nummer des Maximum-Scan-Line-Reg.
#define CC_START_HI    0x0C              // Nummer des Hi-Start-Registers
#define CC_START_LO    0x0D              // Nummer des Lo-Start-Registers
#define CC_ROW_OFFSET  0x13              // Offset zwischen zwei Bildschirmzeilen
#define CC_UNDERLINE   0x14              // Nummer des Underline-Registers
#define CC_MODE_CTRL   0x17              // Nummer des Mode-Control-Registers

#define DAC_WRITE_ADR  0x3C8             // DAC-Write-Adresse
#define DAC_READ_ADR   0x3C7             // DAC-Read-Adresse
#define DAC_DATA       0x3C9             // DAC-Datenregister

#define VERT_RETRACE   0x3DA             // Input Status-Register #1


//###################################################################
//# Makros / Definitionen
//###################################################################

extern void wait_retrace();
#pragma aux wait_retrace = \
        "mov     dx,3dah" \
"@@w1:   in      al,dx"   \
        "test    al,8"    \
        "jnz     @@w1"    \
"@@w2:   in      al,dx"   \
        "test    al,8"    \
        "jz      @@w2"    \
        MODIFY[al dx]

#ifdef DEBUG
   extern void set_debug_farbe(char _x);
   #pragma aux set_debug_farbe = \
        "mov dx, 03c0h" \
        "mov al, 031h" \
        "out dx, al" \
        "mov al, bl" \
        "out dx, al" \
        MODIFY[al dx] \
        PARM[bl]

#else
   #define set_debug_farbe(_x)
#endif

//###################################################################
//# Funktionen from boulder.cpp
//###################################################################

extern void *my_alloc( size_t size );
extern void quit_game();

//###################################################################
extern "C" BYTE *grafik; //Peter was here :->
extern "C" BYTE *grafik4planes;     // In 4 Planes aufgeteilte 16*16 Grafik im Speicher
extern "C" BYTE *schrift;               // Zeiger auf die 16*16 Schrift im Speicher
extern struct feld_element feld[FELD_AUFL_Y][FELD_AUFL_X];
extern int anz_green_slime;       // Wieviele Ambenteile sind im Level herum?
extern int anz_collected_dias;      // Bis jetzt eingesammelte Diamanten
extern int max_anz_green_slime;     // Max. Gre der Ambe
extern char green_slime_frei;       // luft die Ambe noch frei herum?
extern char green_slime_im_level;   // ist die Ambe berhaupt im Level?
extern BYTE hero_x, hero_y;         // die Pos unseres Helden
extern int graphik_modus;           // Der gewhlte Grafikmodus
extern "C" WORD draw_screenx;       // Anzuzeigende Bildschirmauflsung X
extern "C" WORD draw_screeny;       // Anzuzeigende Bildschirmauflsung Y
extern BYTE *feld_grafik[ANZ_SPRITES ];

//###################################################################
//# Funktionen aus kbd2.cpp
//###################################################################

extern short get_kb_command();
extern void install_kbd_handler();

//###################################################################
//# Funktionen aus graphics.cpp                                     #
//###################################################################

extern void setze_palette(unsigned char*);
extern void setze_mode_x();
extern void kopiere_sprites(unsigned char* zeiger,
                     unsigned long anzahl_bytes,
                     unsigned short int ofs);
     /* Kopiert die 16*16 Blcke in den Bildschirmspeicher (fr Mode-X) */

extern void paint_block(unsigned char index,
              unsigned short xpos, unsigned short ypos);
     /* Kopiert im Mode-X einen 16*16 Block gegeben ber 'index' nach
        xpos/ypos auf der aktuellen Bildschirmseite */


//extern void paint_feld_mode_x_1(unsigned char startx, unsigned char starty);
//extern void paint_feld_mode_x_2(unsigned char startx, unsigned char starty);
//extern void paint_feld_mode_x_3(unsigned char startx, unsigned char starty);
extern void paint_feld(int graphik_modus, int starty, int feldx, int feldy, int xaufl, int yaufl);
extern void setze_sprite(unsigned char*, unsigned int,
                                         unsigned int,
                                         unsigned int,
                                         unsigned int);
extern void set_other_page(unsigned char, unsigned char);
extern void blend_ab(unsigned char*);
extern void blend_auf(unsigned char*);
extern void setze_spiel_element(short xpos, short ypos,long index);

//###################################################################

extern "C" unsigned long asm_sprite_start_vram;
extern "C" unsigned short asm_xaufl_feld;
extern "C" unsigned long asm_step_feld;

//###################################################################
//# Funktionen aus animate.cpp                                      #
//###################################################################

extern void animate_tables();
extern unsigned char anim_start_table[];
extern unsigned char anim_end_table[];
extern "C" char anim_convert_table[];

//extern "C" unsigned char anim_convert_table[10];
//#pragma aux (__cdecl) anim_convert_table;

//###################################################################
//# Funktionen aus flames.cpp
//###################################################################

extern void init_flames();
extern void calc_flames();
extern void set_flames_str(char *str, unsigned short xpos, unsigned short ypos);

//###################################################################

extern "C" char ascii_zs[];

//###################################################################
//# Funktionen aus events.cpp
//###################################################################
extern void init_events();
extern void handle_events();
extern void print_status();

//###################################################################
//# Funktionen aus leveled.cpp
//###################################################################
extern void level_edit();

//###################################################################
//# Funktionen aus mem.cpp
//###################################################################

extern void* my_alloc (size_t size );

//###################################################################
//# Funktionen aus menu.cpp
//###################################################################

extern void handle_menu_events();
extern char menu_active;

//###################################################################
//# Pragmas fr speedup.asm
//###################################################################

#pragma aux (__cdecl) anim_convert_table;
#pragma aux (__cdecl) asm_sprite_start_vram;
#pragma aux (__cdecl) asm_xaufl_feld;
#pragma aux (__cdecl) asm_step_feld;
#pragma aux (__cdecl) grafik4planes;

#pragma aux (__cdecl) draw_screenx;
#pragma aux (__cdecl) draw_screeny;

#pragma aux (__cdecl) schrift;
#pragma aux (__cdecl) ascii_zs;

#include "mouse.h"
