// soll eine .vga -datei von Boulder nach pcx umwandeln.
#include <iostream.h>
#include <fstream.h>
#include <assert.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <fcntl.h>
// ##############################################################
char id_byte_pal=0xc;
char pal_1[768];

char *piccy;

// ##############################################################
struct pcx_header
{
    char id;
    char version;
    char kodiert;
    char bpp;
    short xmin;
    short ymin;
    short xmax;
    short ymax;
    short xdpi;
    short ydpi;
    char color_map[16*3];
    char reserved;
    char anz_farb_ebenen;
    short x_bytes;
    short pal1;
    char nix[58];
} header;

// ##############################################################
void main()
{
    unsigned int file_size;
    int rein;
    int pal;
    int raus;
    int i;

    cout << "Lade Palette..." << endl;
    //################################
    pal = open( "default.pal", O_RDONLY | O_BINARY);
    assert (pal != -1);
    read(pal, pal_1, 768);
    close (pal);

    cout << "Lade .vga..." << endl;
    //################################
    rein = open( "boulder.vga", O_RDONLY | O_BINARY);
    assert (rein != -1);
    file_size = filelength( rein );
    piccy = (char *) malloc(file_size);
    assert (piccy != NULL);
    read (rein, piccy, file_size);
    cout << file_size << " Bytes read." << endl;
    close (rein);

    cout << "Speichere .pcx..." << endl;
    //################################
    raus = open( "boul_pic.pcx",
                                O_WRONLY | O_CREAT | O_TRUNC|O_BINARY,
                                S_IRUSR | S_IWUSR | S_IRGRP | S_IWGRP );
    assert (raus != NULL);
    // Header
    //################################
    header.id = 0xa;
    header.version = 5;
    header.kodiert = 1;
    header.bpp=8;
    header.xmin = 1;
    header.ymin = 1;
    header.xmax = 16;
    header.ymax = 16*10 + (file_size / 16); // 10 neue spiel-elemente
    header.xdpi = 302;
    header.ydpi = 302;
    header.anz_farb_ebenen = 1;
    header.x_bytes=16;
    header.pal1=0;

    write (raus, &header, 128);

    // Bilddaten
    //################################
    char ch;
    int alt_ch = -1;
    int anz_gleicher = 0;
    for (i=0;i< file_size;i++)
    {
       if (piccy[i] >= 0x3f)
       {
          ch = 0xc1;
          write(raus, &ch, 1);
          ch = piccy[i];
          write(raus, &ch, 1);
       }
       else
       {
          ch = piccy[i];
          write(raus, &ch, 1);
       }
    }
    for (i=0;i< 16*10;i++)
    {
          ch = 0xc0+16; // eine Zeile auf einmal
          write(raus, &ch, 1);
          ch = 0;
          write(raus, &ch, 1);
    }


    // Palette
    //################################
    for (i=0;i<768;i++) pal_1[i] <<=2;
    write (raus, &id_byte_pal, 1);
    write (raus, pal_1, 768);

    close (raus);
    cout << "Done." << endl;
    //################################

}
